  PROGRAM

!|
!|  Fancy toolbar by Gordon Smith (schmoo@iol.ie)
!|  This program was written using CW 2.0 3.
!|

  MAP
  END

!|
!|  OOP Declarations  ------------------------------
!|

!|
!|  rButt - Region button:  A button with no content.
!|

rButt           CLASS(),MODULE('OOPLIB.CLW') 
rUse              LONG
rInit             PROCEDURE(LONG)
rEvent            FUNCTION(), LONG
                END

!|
!|  sButt - String button:  A button with a display string.
!|

sButt           CLASS(rButt),MODULE('OOPLIB.CLW')   
sUse              LONG
sInit             PROCEDURE(LONG, LONG)
sEvent            FUNCTION(), LONG
                END

!|
!|  isButt - Icon + String button:  A button with a display string and a changing icon.
!|

isButt          CLASS(sButt),MODULE('OOPLIB.CLW')
isUse             LONG
isImageBW         STRING(64)
isImageCol        STRING(64)
isInit            PROCEDURE(LONG, LONG, LONG, STRING, STRING)
isEvent           FUNCTION(), LONG
                END

eIndent         EQUATE(1)                        !  Depth of button

!|
!|  Window declarations
!|

window WINDOW('Show off!'),AT(,,300,200),FONT('MS Sans Serif',8,,FONT:regular),COLOR(08000000CH),ICON(ICON:Application), |
         TIMER(500),PALETTE(256),SYSTEM,GRAY,MAX,RESIZE
       IMAGE('CLOUDS.BMP'),AT(0,0,,34),USE(?Image1),FULL
       PANEL,AT(0,0,94,34),USE(?PanelAll),BEVEL(-1,1)
       REGION,AT(2,2,30,30),USE(?RegionNull),IMM,CURSOR(CURSOR:SizeWE)
       REGION,AT(32,2,30,30),USE(?RegionExit),IMM
       PROMPT('E&xit'),AT(32,22,30,10),FONT(,,080000010H,),USE(?PromptExit),TRN,CENTER
       STRING('Grab the empty button on the left and give it a shake!'),AT(0,34),FONT('Arial',10,00H,FONT:bold+FONT:italic), |
           ANGLE(3600),USE(?String1),FULL,CENTER
       REGION,AT(62,2,30,30),USE(?RegionBeep),IMM
       PROMPT('Beep'),AT(61,21,30,10),FONT(,,080000010H,),USE(?PromptBeep),TRN,CENTER
       IMAGE('BEEPBW.ICO'),AT(69,5,16,16),USE(?ImageBeep)
     END

!|
!|  A sample of each type of button
!|

NullButt        rButt
ExitButt        sButt
BeepButt        isButt

  CODE

  OPEN(window)

!|
!|  Initilize the reee buttons
!|

  NullButt.rInit(?RegionNull)
  ExitButt.sInit(?RegionExit, ?PromptExit)
  BeepButt.isInit(?RegionBeep, ?PromptBeep, ?ImageBeep, 'BeepCOL.ICO', 'BeepBW.ICO')

  ACCEPT
    CASE EVENT()
    OF EVENT:OpenWindow
    OF EVENT:Timer
      LOOP I# = 200 TO 3600 BY 200; YIELD               !Spin the display text
        ?String1{PROP:Angle} = I#
        DISPLAY(?String1)
      END
    END

    CASE NullButt.rEvent()
    OF EVENT:MouseDown                                  !Move controls
      ACCEPT
        CASE EVENT()
        OF EVENT:MouseMove
          XPos# = MOUSEX()
          IF XPos# < 17
            XPos# = 17
          END
          IF XPos# > window{PROP:Width} - 78
            XPos# = window{PROP:Width} - 78
          END
          ?PanelAll{PROP:XPos} = XPos# - 17
          ?RegionNull{PROP:XPos} = XPos# - 15
          ?RegionExit{PROP:XPos} = XPos# + 15
          ?PromptExit{PROP:XPos} = XPos# + 15
          ?RegionBeep{PROP:XPos} = XPos# + 45
          ?PromptBeep{PROP:XPos} = XPos# + 45
          ?ImageBeep{PROP:XPos} = XPos# + 52
          DISPLAY()
        OF EVENT:MouseUp
          POST(EVENT:MouseUp, ?RegionNull)
          BREAK
        END
      END
    END

    CASE ExitButt.sEvent()
    OF EVENT:MouseUp
      POST(EVENT:CloseWindow)
    END

    CASE BeepButt.isEvent()
    OF EVENT:MouseUp
      BEEP
    END

  END
  CLOSE(window)
